-- Acknowledgement: The basic framework for this functionality was borrowed
-- from the ImhoBags AddOn, from file windows\TooltipEnhancer.lua.

local context = UI.CreateContext("ItemRarity")
local window = UI.CreateFrame("Text", "ItemRarity_Tooltip", context)

context:SetStrata("topmost")
window:SetVisible(false)
window:SetBackgroundColor(0, 0, 0, 0.8)

local padding = 10
local verticalOffset = 0

local function displayTooltip(tooltip)
	local left, top, right, bottom = UI.Native.Tooltip:GetBounds()
	local screenHeight = UIParent:GetHeight()
	local height = window:GetHeight()

	window:SetText(tooltip)
	window:SetVisible(true)
	window:ClearAll()
	window:SetPoint("TOPLEFT", UI.Native.Tooltip, "BOTTOMLEFT", padding, verticalOffset)
	window:SetPoint("TOPRIGHT", UI.Native.Tooltip, "BOTTOMRIGHT", -padding, verticalOffset)
end

local function rarityTooltip(ttype, shown, buff)
	window:SetVisible(false)

	if(not (ttype and shown)) then
		return
	end

	if(not (ttype == "item" or ttype == "itemtype")) then
		return
	end

	local item = Inspect.Item.Detail(shown)
	if(not item) then
		return
	end

	local rarity
	if(item.rarity) then
		rarity = item.rarity
	else
		rarity = "common"
	end
	displayTooltip("Rarity: "..rarity)
end

table.insert(Event.Tooltip, {rarityTooltip, "ItemRarity", "rarityTooltip"})
